using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace ProgrammingCSharpWinForm
{

	public class ADOForm1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components;
		private System.Windows.Forms.ListBox lbCustomers;

		public ADOForm1()
		{
			InitializeComponent();

			//  ִ northwind ͺ̽ Ѵ.
			string connectionString = 
			"server=myServer; uid=sa; pwd=; database=northwind";

			//  ̺κ ڵ带 Ѵ. 
			string commandString = 
			"Select CompanyName, ContactName from Customers";

			//    ü DataSet Ѵ.
			SqlDataAdapter DataAdapter = 
			new SqlDataAdapter(
			commandString, connectionString);

			DataSet DataSet = new DataSet();

			//   ü ߰Ѵ. 
			DataAdapter.Fill(DataSet,"Customers");

			// DataSet ̺ ϳ  ´.
			DataTable dataTable = DataSet.Tables[0];
			
			// ̺  ࿡   Ѵ. 
			foreach (DataRow dataRow in dataTable.Rows)
			{
				lbCustomers.Items.Add(
					dataRow["CompanyName"] + 
					" (" + dataRow["ContactName"] + ")" );
			}

		}

		public override void Dispose()
		{
			base.Dispose();
			components.Dispose();
		}

		private void InitializeComponent()
		{
			this.components = 
				new System.ComponentModel.Container ();
			this.lbCustomers = new System.Windows.Forms.ListBox ();
			lbCustomers.Location = new System.Drawing.Point (48, 24);
			lbCustomers.Size = new System.Drawing.Size (368, 160);
			lbCustomers.TabIndex = 0;
			this.Text = "ADOFrm1";
			this.AutoScaleBaseSize = new System.Drawing.Size (5, 13);
			this.ClientSize = new System.Drawing.Size (464, 273);
			this.Controls.Add (this.lbCustomers);
		}

 
		public static void Main(string[] args) 
		{
			Application.Run(new ADOForm1());
		}
	}
}

