using System;
using System.Runtime.Remoting;

using System.Reflection;

namespace ProgCSharp
{
	
	//    ϸ Ӽ ּ óϰ, 
	// ּ   ü(MarshalByRefObject) ǻ츰. 
	[Serializable]
	public class Point  // : MarshalByRefObject
	{
		public Point (int x, int y)
		{
			Console.WriteLine( "[{0}] {1}",
				System.AppDomain.CurrentDomain.FriendlyName, 
				"Point constructor");

			this.x = x;
			this.y = y;
		}

	
		public int X
		{
			get
			{
				Console.WriteLine( "[{0}] {1}",
					System.AppDomain.CurrentDomain.FriendlyName, 
					"Point x.get");

				return this.x;
			}

			set
			{
				Console.WriteLine( "[{0}] {1}",
					System.AppDomain.CurrentDomain.FriendlyName, 
					"Point x.set");
				this.x = value;
			}
		}

		public int Y
		{
			get
			{
				Console.WriteLine( "[{0}] {1}",
					System.AppDomain.CurrentDomain.FriendlyName, 
					"Point y.get");
				return this.y;
			}

			set
			{
				Console.WriteLine( "[{0}] {1}",
					System.AppDomain.CurrentDomain.FriendlyName, 
					"Point y.set");
				this.y = value;
			}
		}

		private int x;
		private int y;
	}

	//    Shape Ŭ 
	public class Shape : MarshalByRefObject
	{
		public Shape(int upperLeftX, int upperLeftY)
		{
			Console.WriteLine( "[{0}] {1}",
				System.AppDomain.CurrentDomain.FriendlyName, 
				"Shape constructor");

			upperLeft = new Point(upperLeftX, upperLeftY);
		}
		public Point GetUpperLeft()
		{
			return upperLeft;
		}

		public void ShowUpperLeft()
		{
			Console.WriteLine( "[{0}] Upper left: {1},{2}",
				System.AppDomain.CurrentDomain.FriendlyName, 
				upperLeft.X, upperLeft.Y);
		}

		private Point upperLeft;
	}
	public class Tester
	{
		public static void Main()
		{

			Console.WriteLine( "[{0}] {1}",
				System.AppDomain.CurrentDomain.FriendlyName, 
				"Entered Main");
	
			// ο  α׷  Ѵ. 
			AppDomain ad2 = 
				System.AppDomain.CreateDomain("Shape Domain");
    
			// Assembly a = Assembly.LoadFrom("ProgCSharp.exe");
			// Object theShape = a.CreateInstance("Shape");
			// Shape ü νϽ Ѵ. 
			ObjectHandle oh = ad2.CreateInstance( 
				"ProgCSharp", 
				"ProgCSharp.Shape", false,
				System.Reflection.BindingFlags.CreateInstance,
				null, new object[] {3, 5},
				null, null, null );

			Shape s1 = (Shape) oh.Unwrap();

			s1.ShowUpperLeft();     // ǥ  ûѴ.

			// 纻̳ Ͻø ´. 
			Point localPoint = s1.GetUpperLeft();

			// ο  ҴѴ. 
			localPoint.X = 500;
			localPoint.Y = 600;

			// localPoint ü  Ѵ. 
			Console.WriteLine( "[{0}] localPoint: {1}, {2}",
				System.AppDomain.CurrentDomain.FriendlyName, 
				localPoint.X, localPoint.Y);

			s1.ShowUpperLeft();     //  ѹ  Ѵ. 
		}
	}
}

