namespace ProgrammingCSharpWindows.Form
{
	using System;
	using System.Drawing;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;
	using System.Data.SqlClient;

	public class ADOForm1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.Container components;
		private System.Windows.Forms.DataGrid dataGrid1;



		// private System.Data.ADO.ADOConnection myConnection;
		private System.Data.SqlClient.SqlConnection myConnection;
		private System.Data.DataSet myDataSet;
		private System.Data.SqlClient.SqlCommand myCommand;
		private System.Data.SqlClient.SqlDataAdapter DataAdapter;
		
		public ADOForm1()
		{
			InitializeComponent();

			//  ü ϰ  ش. 
			string connectionString = 
				"server=Neptune; uid=sa; pwd=oWenmEany; database=northwind";
			myConnection = new  
				System.Data.SqlClient.SqlConnection(connectionString);
			myConnection.Open();

			// DataSet ϰ Ƽ Ѵ. 
			myDataSet = new System.Data.DataSet();
			myDataSet.CaseSensitive=true;

			// SqlCommand ü ϰ, 
			// Ӱ select  Ѵ. 
			myCommand = new System.Data.SqlClient.SqlCommand();
			myCommand.Connection=myConnection;
			myCommand.CommandText = "Select * from Customers";

			// DataAdapter ü ϰ SQL Command ü ϰ,
			// ̺ (mapping) Ѵ.
			DataAdapter = new System.Data.SqlClient.SqlDataAdapter();
			DataAdapter.SelectCommand= myCommand;
			DataAdapter.TableMappings.Add("Table","Customers");

			// DataAdapter ̿Ͽ DataSet Ѵ.
			DataAdapter.Fill(myDataSet);

			// ׸(grid) Ѵ.
			dataGrid1.DataSource=
				myDataSet.Tables["Customers"].DefaultView;  
		}

		public override void Dispose()
		{
			base.Dispose();
			components.Dispose();
		}

		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container ();
			this.dataGrid1 = new System.Windows.Forms.DataGrid ();
			dataGrid1.BeginInit ();
			dataGrid1.Location = new System.Drawing.Point (24, 32);
			dataGrid1.Size = new System.Drawing.Size (480, 408);
			dataGrid1.DataMember = "";
			dataGrid1.TabIndex = 0;
			this.Text = "ADOFrm1";
			this.AutoScaleBaseSize = new System.Drawing.Size (5, 13);
			this.ClientSize = new System.Drawing.Size (536, 501);
			this.Controls.Add (this.dataGrid1);
			dataGrid1.EndInit ();
		}
 
		public static void Main(string[] args) 
		{
			Application.Run(new ADOForm1());
		}
	}
}

