
using System.Xml.Serialization;
using System;
using System.Web.Services.Protocols;
using System.Web.Services;

namespace WSCalc
{
	[System.Web.Services.WebServiceBindingAttribute(
		Name="Service1Soap", 
		Namespace="http://www.libertyAssociates.com/webServices/")]
	public class Service1 : 
		System.Web.Services.Protocols.SoapHttpClientProtocol 
	{
	
		public Service1() 
		{
			this.Url = 
				"http://localhost/webForms/WsCalc/WebService1/Service1.asmx";
		}
    
		[System.Web.Services.Protocols.SoapDocumentMethodAttribute(
			"http://www.libertyAssociates.com/webServices/Add", 
			RequestNamespace=
				"http://www.libertyAssociates.com/webServices/", 
				ResponseNamespace=
					"http://www.libertyAssociates.com/webServices/", 
				Use=System.Web.Services.Description.SoapBindingUse.Literal, 
				ParameterStyle=
					System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
			public System.Double Add(System.Double x, System.Double y) 
			{
				object[] results = this.Invoke("Add", new object[] {x,y});
				return ((System.Double)(results[0]));
			}
	
			public System.IAsyncResult 
				BeginAdd(System.Double x, System.Double y, 
				System.AsyncCallback callback, object asyncState) 
			{
				return this.BeginInvoke("Add", new object[] {x,
								y}, callback, asyncState);
			}
	
			public System.Double EndAdd(System.IAsyncResult asyncResult) 
			{
				object[] results = this.EndInvoke(asyncResult);
				return ((System.Double)(results[0]));
			}
	}
}